@import "@assets/themes/themify.utils.scss";
@import "~/themes.scss";

$arrow-path: "/assets/icons/scenic/select-arrow.svg";

.Select {
  display: block;
  position: relative;
  text-rendering: optimizelegibility;

  .SelectButton {
    display: flex;
    flex-shrink: 0;
    align-items: center;
    position: relative;
    z-index: 10;
    height: 100%;
    width: available;
    width: fill-available;
    width: stretch;
    border: 2px solid;
    border-radius: 4px;

    &:hover {
      cursor: pointer;
    }

    &:focus {
      outline: transparent;
    }

    &[aria-expanded="true"] .SelectIcon {
      transform: rotate(180deg);
    }
  }

  .SelectIcon {
    background: url($arrow-path) no-repeat;
  }

  .SelectField {
    position: relative;
    width: inherit;
    text-rendering: optimizelegibility;
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
  }

  .SelectButton,
  .SelectLabel {
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
  }

  &-normal {
    font-size: 14px;

    .SelectIcon {
      width: 12px;
      height: 12px;
      margin: 10px;
    }

    .SelectField {
      margin-left: 14px;
    }
  }

  &-tiny {
    font-size: 12px;

    &,
    .SelectButton {
      height: 20px;
    }

    .SelectIcon {
      width: 8px;
      height: 8px;
      margin: 4px;
    }

    .SelectField {
      margin-left: 4px;
    }
  }

  &-disabled .SelectButton {
    cursor: not-allowed;
    border-radius: 0;
  }
}

@include themify("Select", $themes) {
  font-family: themed("font-family");

  .SelectButton {
    background-color: themed("field-background-editable");
    border-color: themed("field-background-editable");

    &:hover,
    &:focus,
    &[aria-expanded="true"] {
      border-color: themed("status-focus");
    }
  }

  .SelectField {
    font-family: themed("font-family");
    color: themed("field-text");
  }

  .SelectPlaceholder {
    color: themed("field-text-placeholder");
  }

  &.Select {
    &-danger .SelectButton {
      border-color: themed("status-danger");
    }

    &-busy .SelectButton {
      border-color: themed("status-busy");
    }

    &-active .SelectButton {
      border-color: themed("status-active");
    }

    &-inactive .SelectButton {
      border-color: themed("status-inactive");
    }

    &-disabled {
      color: themed("field-text-disabled");

      .SelectButton {
        background-color: themed("field-background-disabled");
        border-color: themed("field-background-disabled");
      }

      .SelectField {
        color: themed("field-text-disabled");
      }
    }
  }
}
